use std::collections::HashMap;

use crate::{common::loc::LocBox, tokeniser::tokentype::*};

use super::{expr::Expr, typ::Type, Ast};

#[derive(Debug, Clone)]
pub enum Literal {
    Number(Number),
    Ident(Ident),
    String(TString),
    Char(Char),
    Array(Vec<LocBox<Expr>>),
    ArrayRepeat {
        val: Box<LocBox<Expr>>,
        count: Box<LocBox<Expr>>,
    },
}
