use crate::targets::Target;
use std::io::Write;
pub struct AsmGen;

impl Target for AsmGen {
    fn new() -> Self {
        Self {}
    } 
    fn get_target_triple() -> &'static str {
        "x86_64-asmgen-linux"
    }
    fn get_int_ext(&self) -> &'static str {
        "s"
    }
    fn write_code(&mut self, program: &crate::parser::ast::Program, path: &std::path::Path) -> anyhow::Result<()> {
        let mut f = std::fs::File::open(path)?;
        writeln!(f, "section .text")?;

        writeln!(f, "section .rodata")?;
        for (name, constant) in &program.const_vars {
            writeln!(f, "{name}:")?;
        }
        Ok(()) 
    }
    fn compile(&mut self, _from: &std::path::Path, _to: &std::path::Path) -> anyhow::Result<()> {
        Ok(())
    }
    fn link(&mut self, _from: Vec<std::path::PathBuf>, _to: &std::path::Path) -> anyhow::Result<()> {
        Ok(())
    }
}
